from enum import Enum
from typing import List, Tuple

class Jieba:
    # 构造函数
    def __init__(
        self,
        dict_path: str,
        model_path: str,
        user_dict_path: str,
        idf_path: str = ...,
        stop_word_path: str = ...,
        dat_cache_path: str = ...
    ) -> None: ...

    def cut(self, sentence: str, hmm: bool = ...) -> List[str]: ...
    def cut_all(self, sentence: str) -> List[str]: ...
    def cut_for_search(self, sentence: str, hmm: bool = ...) -> List[str]: ...

    # 词性标注
    def tag(self, sentence: str) -> List[Tuple[str, str]]: ...
    def lookup_tag(self, word: str) -> str: ...

    # 查找
    def find(self, word: str) -> bool: ...

    def extract_keywords(self, sentence: str, top_k: int = ...) -> List[Tuple[str, float]]: ...
